//create_iss_modnum
//
//Fonction qui gnre le texte d'un fichier de configuration
//pour Inno Setup (Windows installer) pour la version
//binaire windows de modnum
function [txt]=create_iss_modnum()

 //set here directories to be explored (in MODNUM)
 macros_dir = 'macros\'+...
             ['build_util';
              'find_file';
              'misc';
              'scicos_blocks\Communication';
              'scicos_blocks\Filter';
              'scicos_blocks\NonLinear';
              'scicos_blocks\Old'
              'scicos_blocks\Pll';
              'scicos_blocks\Sinks';
              'scicos_blocks\Sources';
              'scicos_blocks\Tools';
              'scicos_util';
              'scicos_overload';
              'signal';];

 pal_dir = ['macros\scicos_blocks'];

 routines_dir = 'routines\'+...
               ['modnum_lib';
//                'scicos\codegen';
                'scicos\communication';
                'scicos\filter';
                'scicos\nonlinear';
                'scicos\old';
                'scicos\other';
                'scicos\pll';
                'scicos\sinks';
                'scicos\sources';
                'scicos\tools'];

 headers_dir = 'routines\sci_headers\'+...
               ['f2c';
                'graphics';
                'sparse'];

 gif_dir = ['man\images';
            'macros\gif_icons'];

 demos_dir = ['man\demos'];

 help_en_xml_dir  = ['man\eng\xml'];
 help_en_html_dir = ['man\eng\htm'];
 help_fr_xml_dir  = ['man\fr\xml'];
 help_fr_html_dir = ['man\fr\htm'];

 diagr_dir = ['scs_diagr']

 simu_dir = ['simu']

 //######## Bsource ########//
  tt_Bsource = [];
  //root
  tt_Bsource = ["builder.sce; DestDir: {app};"
                "configure.ac; DestDir: {app};"
                "Makefile; DestDir: {app};"
                "Makefile.am; DestDir: {app};"
                "Makefile.incl; DestDir: {app};"];
  //macros
  tt_Bsource = [tt_Bsource
                "macros\Makefile; DestDir: {app}\macros;"
                macros_dir+"\Makefile; DestDir: {app}\"+macros_dir+";"];
  //routines
  tt_Bsource = [tt_Bsource
                "routines\Makefile; DestDir: {app}\routines;"
                routines_dir+"\Makefile; DestDir: {app}\"+routines_dir+";"];
  //headers
  tt_Bsource = [tt_Bsource
                headers_dir+"\*.h; DestDir: {app}\"+headers_dir+";"];

 //######## modnum_bin ########//
  tt_modnum_bin = [];
  //root
  tt_modnum_bin = [tt_modnum_bin
                   "loader.sce; DestDir: {app};"]
  //macros
  tt_modnum_bin = [tt_modnum_bin
                   macros_dir+"\*.bin; DestDir: {app}\"+macros_dir+";"
                   macros_dir+"\lib; DestDir: {app}\"+macros_dir+";"
                   macros_dir+"\names; DestDir: {app}\"+macros_dir+";"];
  //routines
  tt_modnum_bin = [tt_modnum_bin
                   routines_dir+"\*.dll; DestDir: {app}\"+routines_dir+";"
                   routines_dir+"\*.ilib; DestDir: {app}\"+routines_dir+";"
                   routines_dir+"\loader.sce; DestDir: {app}\"+routines_dir+";"];
  //palette
  tt_modnum_bin = [tt_modnum_bin
                   pal_dir+"\*.cosf; DestDir: {app}\"+pal_dir+";"];

 //######## SCIsource ########//
  tt_SCIsource = [];
  //macros
  tt_SCIsource = [tt_SCIsource
                   macros_dir+"\*.sci; DestDir: {app}\"+macros_dir+";"];

 //######## Csource ########//
  tt_Csource = [];
  //routines
  tt_Csource = [tt_Csource
                routines_dir+"\*.c; DestDir: {app}\"+routines_dir+";"];

 //######## demos ########//
  tt_demos = [];
  //diagrams
  tt_demos = [tt_demos
              diagr_dir+"\*.*; DestDir: {app}\"+diagr_dir+"; Flags: recursesubdirs;"];
  //simu
  tt_demos = [tt_demos
              simu_dir+"\*.*; DestDir: {app}\"+simu_dir+"; Flags: recursesubdirs;"];

 //######## help ########//
  tt_help = [];
  //gif_icons & images
  tt_help = [tt_help
             gif_dir+"\*.gif; DestDir: {app}\"+gif_dir+";"];
  //demos
  tt_help = [tt_help
             demos_dir+"\*.dem; DestDir: {app}\"+demos_dir+";"];

 //######## help\en ########//
  tt_help_en = [];
  //xml
  tt_help_en = [tt_help_en
                help_en_xml_dir+"\*.xml; DestDir: {app}\"+help_en_xml_dir+";"];
  //html
  tt_help_en = [tt_help_en
                help_en_html_dir+"\*.htm; DestDir: {app}\"+help_en_html_dir+";"];

 //######## help\fr ########//
  tt_help_fr = [];
  //xml
  tt_help_fr = [tt_help_fr
                help_fr_xml_dir+"\*.xml; DestDir: {app}\"+help_fr_xml_dir+";"];
  //html
  tt_help_fr = [tt_help_fr
                help_fr_html_dir+"\*.htm; DestDir: {app}\"+help_fr_html_dir+";"];

  txt=["; permanent files"
       "Source : Readme_en.txt; DestDir: {app};"
       "Source : Readme_fr.txt; DestDir: {app};"
       "Source : Version.txt; DestDir: {app};"
       ""
       "; build files"
       "Source : "+tt_Bsource+" Components: Bsource"
       ""
       "; binary files"
       "Source : "+tt_modnum_bin+" Components: modnum_bin"
       ""
       "; macros files"
       "Source : "+tt_SCIsource+" Components: SCIsource"
       ""
       "; C files"
       "Source : "+tt_Csource+" Components: Csource"
       ""
       "; demos files"
       "Source : "+tt_demos+" Components: demos"
       ""
       "; help files"
       "Source : "+tt_help+" Components: help"
       ""
       "; help files en"
       "Source : "+tt_help_en+" Components: help\en"
       ""
       "; help files fr"
       "Source : "+tt_help_fr+" Components: help\fr"]

 //########### body #################
  txt=["; -- modnum.iss --"
       ";"
       "; This a modnum.iss for Inno Setup"
       "; "+get_modnum_version();
       "; "+date()
       "; Author : create_iss_modnum"
       ""
       "[Setup]"
       "AppName=Modnum"
       "AppVerName=Modnum version 4.1.2"
       "DefaultDirName={userdocs}\modnum_412"
       "DirExistsWarning=yes"
       "OutputDir=userdocs:MODNUM"
       "OutputBaseFilename=modnum_412_bin"
       "Compression=lzma"
       "SolidCompression=yes"
       ""
       "[Languages]"
       "Name: en; MessagesFile: ""compiler:Default.isl"""
       "Name: fr; MessagesFile: ""compiler:Languages\French.isl"""
       ""
       "[Types]"
       "Name: ""default""; Description: ""Default installation""; Languages: en;"
       "Name: ""default""; Description: ""Installation par dfaut""; Languages: fr;"
       ""
       "Name: ""compact""; Description: ""Compact installation""; Languages: en;"
       "Name: ""compact""; Description: ""Installation compacte""; Languages: fr;"
       ""
       "Name: ""source""; Description: ""Source only""; Languages: en;"
       "Name: ""source""; Description: ""Sources seulement""; Languages: fr;"
       ""
       "Name: ""custom""; Description: ""Custom installation""; Flags: iscustom"
       ""
       "[Components]"
       "; Binaries"
       "Name: ""modnum_bin""; Description: ""Fichiers binaires""; Types: default compact; Languages: fr;"
       "Name: ""modnum_bin""; Description: ""Binaries files""; Types: default compact; Languages: en;"
       "; Macros source"
       "Name: ""SCIsource""; Description: ""Macros source code""; Types: default source; Languages: en;"
       "Name: ""SCIsource""; Description: ""Code source des macros""; Types: default source; Languages: fr;"
       "; C source"
       "Name: ""Csource""; Description: ""Routines source code""; Types: default source; Languages: en;"
       "Name: ""Csource""; Description: ""Code source des routines""; Types: default source; Languages: fr;"
       "; Builder/Makefile"
       "Name: ""Bsource""; Description: ""Files for building (builder, Makefile,...)""; Types: source; Languages: en;"
       "Name: ""Bsource""; Description: ""Fichers pour la compilation (builder, Makefile,...)""; Types: source; Languages: fr;"
       "; demos"
       "Name: ""demos""; Description: ""Demonstrations and examples""; Types: default; Languages: en;"
       "Name: ""demos""; Description: ""Exemples et dmonstrations""; Types: default; Languages: fr;"
       "; help"
       "Name: ""help""; Description: ""Fichiers d''aides""; Types: default; Languages: fr;"
       "Name: ""help\fr""; Description: ""Franais""; Types: default; Languages: fr;"
       "Name: ""help\en""; Description: ""Anglais""; Types: default compact; Languages: fr;"
       "Name: ""help""; Description: ""Help files""; Types: default; Languages: en;"
       "Name: ""help\en""; Description: ""English""; Types: default compact; Languages: en;"
       "Name: ""help\fr""; Description: ""French""; Types: default; Languages: en;"
       ""
       "[Files]"
       ";README"
       "Source: ""Readme_en.txt""; DestDir: ""{app}""; Languages: en; Flags: isreadme"
       "Source: ""Readme_fr.txt""; DestDir: ""{app}""; Languages: fr; Flags: isreadme"
       "Source: ""Version.txt""; DestDir: ""{app}""; Flags: isreadme"
       ""
       txt]

endfunction
