/* decodvec Vectorial decoder block
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 14 dec 2004 - IRCOM Lab - Author : Alan
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "modnum_lib.h"
#include "scicos_block.h"

/*
 * entres rgulires : u1[0..nu1-1] : vecteur d'entre de code o symbole 1
 *                      u2[0..nu2-1] : vecteur d'entre de code o symbole 2
 *
 * sorties rgulires : y[0..ny-1] : vecteur de sorties de taille ny=nu1 ou ny=nu2
 *
 * paramtres entiers : ipar[0] : numro du port d'entre contenant le code
 */

/*prototype*/
void decodvec(scicos_block *block,int flag)
{
  /*Dclaration des variables*/
  double *uc,*us;
  double *y;
  int k;
  int nuc,nus;
  int n_c,n_s; /* numro des ports code(n_c) et symbole(n_s)*/

  /*determination des numros de ports*/
  n_c=block->ipar[0];
  if (n_c==0)
   n_s=1;
  else
   n_s=0;

  /*Rcupration des adresses des ports rguliers*/
  uc=(double *)block->inptr[n_c];
  us=(double *)block->inptr[n_s];
  y=(double *)block->outptr[0];

  /*fprintf(stderr,"flag=%d,t=%f\n",flag,get_scicos_time()); */
  /*Rcupration de la taille des ports d'entres*/
  nuc=block->insz[n_c];
  nus=block->insz[n_s];

  /*attention*/
  k=nus/nuc; /*doit tjs etre entier*/

  /*Appel routine decod_c*/
  decod_c(&nuc,&k,&uc[0],&us[0],&y[0]);
}
