/* demodqam Scicos demodulator QAM block
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 5 janvier 2005 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "scicos_block.h"

/* Cette fonction de simulation ralise un decodage QAM dfini par la fonction
 * modqam.c. Les signaux I et Q reu en entre sont converti aux valeurs des
 * bits de poids fort et des bits de poids faibles du numro symbole.
 * Les valeurs converties sont ensuite additionnes et la somme est place
 * dans le registre de sortie y[].
 *
 * Entres rgulires : u1[0..insz[0]-1]: vecteur des signaux I
 *                      u2[0..insz[0]-1]: vecteur des signaux Q
 * Sortie rgulire :   u[0..insz[0]-1] : vecteur des numros symboles
 * Entre vnementielle : instants de dcision
 * Sortie vnementielle : nant
 * Paramtres entiers : ipar[0..insz[0]-1] : vecteur des nombres de bits.
 *
 * nb : ne fonctionne que pour des modulations avec un nombre de valeurs
 *     identiques pour chaque axes I et Q(16QAM, 64QAM, 256QAM, ...)
 */

/* demodqamv_c routine de calcul d'un dmodulataur mQAM
 *
 * Entres :
 * n :longueur des vecteurs d'entres
 * m :longueurs des mots binaires en nombre de bits (vecteur)
 * i_c :adresse de dpart du vecteur de la composante I
 * q_c :adresse de dpart du vecteur de la composante Q
 *
 * Sortie :
 * y : adresse de dpart du vecteur du symbole
 *
 * Dpendances:
 */
void demodqamv_c(int *n,int *m,double *i_c,double *q_c,double *y)
{
 /*dclaration des variables*/
 int i;
 int ng,nd;
 int d,g;

 for(i=0;i<(*n);i++)
 {
  /*Rcupration du nombre d'tats*/
  /*n=block->ipar[i];*/

  /*Calcul des slecteurs binaires (c'est maladroit!!)*/
  nd=(1<<(m[i])/2)-1;
  ng=(1<<(m[i]))-1-nd;
  /*fprintf(stderr,"nd=%d, ng=%d\n", nd,ng);*/

  /*rcupration des valeurs d'entre*/
  d=(int)i_c[i];
  g=(int)q_c[i];

  /*Calcul les nombres binaires droit et gauche*/
  d=(d+nd)/2;
  g=((g+nd)/2)<<((m[i])/2);

  /*Calcul du registre de sortie y[]*/
  y[i]=d+g;
 }
 return;
}

/*prototype*/
void demodqam(scicos_block *block,int flag)
{
 /*dclaration des variables*/
 double *y;
 double *u1,*u2;
 int nu;

 /*Rcupration des adresses des ports rguliers*/
 y=(double *)block->outptr[0];
 u1=(double *)block->inptr[0];
 u2=(double *)block->inptr[1];

 /*rcupration de la taille des ports d'entres*/
 nu=block->insz[0];

 /*Le flag 1 calcule le numro symbole*/
 if(flag==1)
 {
  /*Appel demoqamv_c*/
  demodqamv_c(&nu,&block->ipar[0],&u1[0],&u2[0],&y[0]);
 }
}
