/* int_symb scicos Symbol Integrator
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 22 Dcembre 2004 Author : - IRCOM GROUP - A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "modnum_lib.h"
#include "scicos_block.h"

/* Entre rgulire : u[0..nu] : vecteur  intgrer
 * Sortie rgulire : y[0..nu]=integral(u[0..nu]) : vecteur intgr
 * Entre vnementielle : ( la rigueur)
 * Sortie vnementielle : nant
 *
 * Paramtres entier : ipar[0] : Longueur en chantillons du symbole
 *                     ipar[1] : N Echantillon initial d'integration
 *                     insz[0] : taille du vecteur d'entre
 *
 * Paramtres rels :  rpar[0] : gain en sortie
 *
 * Etat discret : z[0] : mmoire valeur intgre prcedente (pour le bout du vecteur)
 *
 */

/*prototype*/
void int_symb(scicos_block *block,int flag)
{
  /*Dclaration des variables*/
  double *y;
  double *u;
  double step;
  int init_c,nu,nech;
  int mu=1;

  /*Rcupration des adresses des ports rguliers*/
  y=(double *)block->outptr[0];
  u=(double *)block->inptr[0];

  /*Rcupration du nombre d'chantillons*/
  nu=block->insz[0];
  nech=block->ipar[0];
  init_c=block->ipar[1];
  step=block->rpar[0];

  /*Le flag1*/
  if(flag==1)
  {
   /*Appel intsymb_c*/
   intsym_c(&nu,&mu,&nech,&init_c,&step,&u[0],&y[0],&block->z[0]);
  }
}
