/* tanhblk Scicos hyperbolic tangent block
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7
 * 13 octobre 2003 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include<math.h>

#include "machine.h"

/* Ce bloc ralise l'opration y[0]=rpar[0]*tanh(rpar[1]*u[0])
 * entres rgulires : vecteur des entres u[0..nu-1]
 * sorties rgulires : vecteurs des sorties y[0..nu-1]
 * entres et sorties d'venement : nant
 * paramtres rlls rpar[0..nu-1] : vecteur du gain
 *                  rpar[nu..2*nu-1] : vecteur du coefficient
 */

/*prototype*/
void tanhblk(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
             ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
 /*dclaration des variables*/
 double *y;
 double *u;
 double t1,t2;
 int i,nu;

 /*rcupration des adresses des ports rguliers*/
 y = (double *)outptr[0];
 u = (double *)inptr[0];

 /*rcupration de la taille du port d'entre*/
 nu=insz[0];

 for(i=0;i<nu;i++)
 {
  t1=exp(rpar[nu+i]*u[i]);
  t2=exp(-rpar[nu+i]*u[i]);
  y[i]=rpar[i]*((t1-t2)/(t1+t2));
 }
}
