/* cpf Scicos Phase/frequency Comparator block
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 6 janvier 2005 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "modnum_lib.h"
#include "scicos_block.h"

/* Cette fonction de simulation ralise un comparateur phase frquence
 * trois tats. Elle calcule les signaux discrets Up(t) et Down(t) qui
 * sont les sorties logiques de deux bascules D. Les entres de ces bascules
 * sont places  1 et les entres d'horloges de celles-ci sont les entres
 * vnementielles du bloc. Lorsque les sorties des deux bascules sont toutes
 * les deux places  1, la fonction place les sorties du bloc y[0] et y[1]  0.
 *
 * entres d'venements : dates d'vnements Ref(t), Div(t)
 * sortie d'venement  : nant
 * entre rgulires : nant
 * Sortie rgulires : Up(t) et Down(t)
 * paramtres : nant
 * Etats discrets : z[0] et z[1] mmorisent les tats prcdents des sorties des bascules
 */

/*prototype*/
void cpf(scicos_block *block,int flag)
{
 /*dclaration*/
 int k;
 int nev;
 double *y1, *y2;

 /*rcupration des adresses*/
 y1=(double *)block->outptr[0];
 y2=(double *)block->outptr[1];
 nev=block->nevprt;

 /* Le flag 1 met  jour les sorties un test est ralis sur les tats prcdents*/
 if(flag==1)
 {
  /*Appel cpf_c*/
  cpf_c((k=1,&k),&nev,&block->z[0],&block->z[1],&y1[0],&y2[0]);
 }
}
