/* genint Scicos Random Integer Generator block
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 3 janvier 2005 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include <math.h>
#include <stdlib.h>

#include "machine.h"
#include "scicos_block.h"

extern integer C2F(dcopy)();

/* Ce bloc est gnrateur de nombre entier alatoire. Il peut gnrer des trains binaires
 * type RZ ou NRZ ou bien des nombres entiers de longueurs dtermines, signs ou non signs
 *
 * entres rgulires : nant
 * sorties rgulires : sortie du gnrateur
 * entre vnementielle : dtermine la cadence de gnration
 *
 * paramtres entiers : ipar[0..outsz[0]-1] : vecteur du nombre de bit du mot de sortie
 *                      ipar[outsz[0]..2*outsz[0]-1]: vecteur du type de gnrateur
 *
 * nb : Type 0: gnre 1 seul bit cod NRZ
 *           1: gnre 1 seul bit cod RZ, ou un mot non sign
 *           2: gnre un mot cod code complment  2
 */

/* genintv_c routine de calcul de mots entiers alatoires
 *
 * Entres :
 * n   : taille du  vecteur de sortie (scalaire)
 * m   : longueur des mots binaires des lments du vecteur de sorties (vecteur)
 * typ : type des gnrateurs binaires (vecteur)
 * (typ=0: gnre 1 seul bit cod NRZ
 *    =1: gnre 1 seul bit cod RZ, ou un mot non sign
 *    =2: gnre un mot cod code complment  2)
 * Sorties :
 * y : vecteur de sortie
 *
 * dpendances
 * math.h
 */
void genintv_c(int *n,int *m,int *typ,double *y)
{
 /*dclaration des variables compteurs*/
 int k,i,j;

 for(i=0;i<(*n);i++)
 {
  switch (typ[i])
  {
   /*Type 0 -> ddi signal NRZ*/
   case 0:
   {
    y[i]=(int)((rand()&1)*2-1);
    break;
   }
   /*Type 1 -> entier non sign*/
   case 1 :
   {
    k=1;
    k=k<<m[i];
    j=rand();
    y[i]=(j&(k-1));
    break;
   }
   /*Type 2 -> entier code complmnt  2*/
   case 2 :
   {
    j=rand();
    j -= 2<<(m[i]-2);
    j &= (2<<(m[i]-1)) - 1;
    j -= 2<<(m[i]-2);
    y[i]=j;
    break;
   }
   break;
  }
 }
 return;
}

/*prototype*/
void genint(scicos_block *block,int flag)
{
    /*Dclaration des variables*/
    double *y;
    int k;
    int ny;

    /*Rcupration de l'adresse du port de sortie rgulier*/
    y=(double *)block->outptr[0];

    /*Rcupration de la taille du vecteur de sortie*/
    ny=block->outsz[0];

    /*Le flag 1 recopie le vecteur Z dans le vecteur Y*/
    if (flag==1||flag==6)
    {
        k=1;
        C2F(dcopy)(&ny,&block->z[0],&k,&y[0],&k);
    }
    /*Le flag 2 calcul les valeurs ou mots binaires dans Z*/
    else if(flag==2||flag==4)
    {
     /*Appel binv_c*/
     genintv_c(&ny,&block->ipar[0],&block->ipar[ny],&block->z[0]);
    }
}
