/* overlap Scicos temporal overlap vector
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 5 dcembre 2005 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "machine.h"
#include "scicos_block.h"

extern integer C2F(dcopy)();

/* Cette fonction transforme un vecteur de taille nu en vecteur de taille ny,
 * avec nu>ny. Elle mmorise l'excs nu-ny et ajoute celui au dbut du vecteur
 * suivant.
 * Entres rgulires : u[0..nu-1] : vecteur d'entre de taille nu
 * sorties rgulires : y[0..ny-1] : vecteur de sortie de taille ny
 * paramtres entiers : nz : taille du vecteur Z
 */

/*prototype*/
void overlap(scicos_block *block,int flag)
{
  /*dclaration*/
  double *y;
  double *u;
  double *z;
  int i,nu,ny,k,l;

  /*rcupration de l'adresse des ports rguliers*/
  y=(double *)block->outptr[0];
  u=(double *)block->inptr[0];
  z=block->z;

  /*Rcupration de la taille des ports rguliers*/
  nu=block->insz[0];
  ny=block->outsz[0];

  /*La flag 1 calcule y*/
  if(flag==1)
   {
    /*Recopie les ny premiers lments de u dans y*/
    C2F(dcopy)(&ny,&u[0],(i=1,&i),&y[0],(k=1,&k));

    /*Ajoute les nz lments prcdents au dbut du vecteur y*/
    for(i=0;i<block->nz;i++) y[i]=u[i]+z[i];
   }
  /*Le flag 2 mais en mmoire l'xcs nz de u dans Z*/
  else if(flag==2)
  {
   /*Recopie les nz xcdentaires de u dans z*/
   C2F(dcopy)((l=block->nz,&l),&u[ny],(i=1,&i),&z[0],(k=1,&k));
  }
}
