/* overlaprsr Scicos right shift register with memo word block
 * Type 4 simulation function ver 1.0 - scilab-2.6&2.7
 * 24 Dcembre 2004 Author : - IRCOM GROUP - A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "modnum_lib.h"
#include "scicos_block.h"

/* Cette fonction de simulation dcale le vecteur reu en entre de nz
 * cases vers la droite et le recopie en sortie y. L'execendent du mot
 * dcal est stock dans Z puis plac au dbut du vecteur suivant.
 *
 * Entre rguliere : u[0..nu-1] vecteur d'entre  dcaler
 * Sortie reguliere : y[0..nu-1] vecteur de sortie dcal
 * 
 * Entre vnementielle : nant
 * Sortie vnementielle : nant
 *
 * Paramtres entier : insz[0] : taille du vecteur en entre
 *                     nz : longueur du mot mmoire
 */

/*prototype*/
void overlaprsr(scicos_block *block,int flag)
{
  /*Dclaration des variables*/
  double *y;
  double *u;
  double *z;
  int nu,l;

  /*Rcupration des adresses des ports rguliers*/
  y=(double *)block->outptr[0];
  u=(double *)block->inptr[0];
  z=block->z;

  /*Rcupration de la taille du port d'entre*/
  nu=block->insz[0];

  /*Rcupration de la longueur du mot mmoire*/
  l=block->nz;

  /* Le flag1 dcale  droite le vecteur d'entre nz fois
   * puis le place dans y et mmorise l'excedent du mot vecteur
   * d'entre dans z
   */

  if(flag==1)
  {
   /*Appel overlaprsr_c*/
   overlaprsr_c(&nu,&l,&u[0],&y[0],&z[0]);
  }
}
